using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Msg_List
    /// </summary>
    public partial class T_Msg_List
    {
        public T_Msg_List()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Msg_List");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Msg_List model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Msg_List(");
            strSql.Append("Type,Detail,State,ToUser,ToID,Remark,CreateUser,CreateDate,ReadDate,IsDel,DelUser,DelDate)");
            strSql.Append(" values (");
            strSql.Append("@Type,@Detail,@State,@ToUser,@ToID,@Remark,@CreateUser,@CreateDate,@ReadDate,@IsDel,@DelUser,@DelDate)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@Detail", SqlDbType.NVarChar,-1),
                    new SqlParameter("@State", SqlDbType.Int,4),
                    new SqlParameter("@ToUser", SqlDbType.VarChar,50),
                    new SqlParameter("@ToID", SqlDbType.Int,4),
                    new SqlParameter("@Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@ReadDate", SqlDbType.DateTime),
                    new SqlParameter("@IsDel", SqlDbType.Int,4),
                    new SqlParameter("@DelUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DelDate", SqlDbType.DateTime)};
            parameters[0].Value = model.Type;
            parameters[1].Value = model.Detail;
            parameters[2].Value = model.State;
            parameters[3].Value = model.ToUser;
            parameters[4].Value = model.ToID;
            parameters[5].Value = model.Remark;
            parameters[6].Value = model.CreateUser;
            parameters[7].Value = model.CreateDate;
            parameters[8].Value = model.ReadDate;
            parameters[9].Value = model.IsDel;
            parameters[10].Value = model.DelUser;
            parameters[11].Value = model.DelDate;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Msg_List model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Msg_List set ");
            strSql.Append("Type=@Type,");
            strSql.Append("Detail=@Detail,");
            strSql.Append("State=@State,");
            strSql.Append("ToUser=@ToUser,");
            strSql.Append("ToID=@ToID,");
            strSql.Append("Remark=@Remark,");
            strSql.Append("CreateUser=@CreateUser,");
            strSql.Append("CreateDate=@CreateDate,");
            strSql.Append("ReadDate=@ReadDate,");
            strSql.Append("IsDel=@IsDel,");
            strSql.Append("DelUser=@DelUser,");
            strSql.Append("DelDate=@DelDate");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@Detail", SqlDbType.NVarChar,-1),
                    new SqlParameter("@State", SqlDbType.Int,4),
                    new SqlParameter("@ToUser", SqlDbType.VarChar,50),
                    new SqlParameter("@ToID", SqlDbType.Int,4),
                    new SqlParameter("@Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@ReadDate", SqlDbType.DateTime),
                    new SqlParameter("@IsDel", SqlDbType.Int,4),
                    new SqlParameter("@DelUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DelDate", SqlDbType.DateTime),
                    new SqlParameter("@ID", SqlDbType.Int,4)};
            parameters[0].Value = model.Type;
            parameters[1].Value = model.Detail;
            parameters[2].Value = model.State;
            parameters[3].Value = model.ToUser;
            parameters[4].Value = model.ToID;
            parameters[5].Value = model.Remark;
            parameters[6].Value = model.CreateUser;
            parameters[7].Value = model.CreateDate;
            parameters[8].Value = model.ReadDate;
            parameters[9].Value = model.IsDel;
            parameters[10].Value = model.DelUser;
            parameters[11].Value = model.DelDate;
            parameters[12].Value = model.ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Msg_List ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Msg_List ");
            strSql.Append(" where ID in (" + IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Msg_List GetModel(int ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 ID,Type,Detail,State,ToUser,ToID,Remark,CreateUser,CreateDate,ReadDate,IsDel,DelUser,DelDate from T_Msg_List ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            CallCenterApi.Model.T_Msg_List model = new CallCenterApi.Model.T_Msg_List();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Msg_List DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Msg_List model = new CallCenterApi.Model.T_Msg_List();
            if (row != null)
            {
                if (row["ID"] != null && row["ID"].ToString() != "")
                {
                    model.ID = int.Parse(row["ID"].ToString());
                }
                if (row["Type"] != null && row["Type"].ToString() != "")
                {
                    model.Type = int.Parse(row["Type"].ToString());
                }
                if (row["Detail"] != null)
                {
                    model.Detail = row["Detail"].ToString();
                }
                if (row["State"] != null && row["State"].ToString() != "")
                {
                    model.State = int.Parse(row["State"].ToString());
                }
                if (row["ToUser"] != null)
                {
                    model.ToUser = row["ToUser"].ToString();
                }
                if (row["ToID"] != null && row["ToID"].ToString() != "")
                {
                    model.ToID = int.Parse(row["ToID"].ToString());
                }
                if (row["Remark"] != null)
                {
                    model.Remark = row["Remark"].ToString();
                }
                if (row["CreateUser"] != null)
                {
                    model.CreateUser = row["CreateUser"].ToString();
                }
                if (row["CreateDate"] != null && row["CreateDate"].ToString() != "")
                {
                    model.CreateDate = DateTime.Parse(row["CreateDate"].ToString());
                }
                if (row["ReadDate"] != null && row["ReadDate"].ToString() != "")
                {
                    model.ReadDate = DateTime.Parse(row["ReadDate"].ToString());
                }
                if (row["IsDel"] != null && row["IsDel"].ToString() != "")
                {
                    model.IsDel = int.Parse(row["IsDel"].ToString());
                }
                if (row["DelUser"] != null)
                {
                    model.DelUser = row["DelUser"].ToString();
                }
                if (row["DelDate"] != null && row["DelDate"].ToString() != "")
                {
                    model.DelDate = DateTime.Parse(row["DelDate"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ID,Type,Detail,State,ToUser,ToID,Remark,CreateUser,CreateDate,ReadDate,IsDel,DelUser,DelDate ");
            strSql.Append(" FROM T_Msg_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" ID,Type,Detail,State,ToUser,ToID,Remark,CreateUser,CreateDate,ReadDate,IsDel,DelUser,DelDate ");
            strSql.Append(" FROM T_Msg_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Msg_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Msg_List T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Msg_List";
			parameters[1].Value = "ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

